---
title: env()
slug: Web/CSS/env()
tags:
  - CSS
  - CSS Function
  - CSS Variables
  - Draft
  - Function
  - Reference
  - Variables
  - env
  - env()
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>env()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> can be used to insert the value of a user agent-defined environment variable into your CSS, in a similar fashion to the {{cssxref("var")}} function and <a href="/en-US/docs/Web/CSS/--*">custom properties</a>. The difference is that, as well as being user-agent defined rather than user-defined, environment variables are globally scoped to a document, whereas custom properties are scoped to the element(s) on which they are declared. </span></p>

<p>To tell the browser to use the whole available space on the screen, and so enabling us to use the <code>env()</code> variables, we need to add a new viewport meta value:</p>

<pre class="brush: html; no-line-numbers notranslate">&lt;meta name="viewport" content="viewport-fit=cover" /&gt;</pre>

<pre class="brush: css; no-line-numbers notranslate">body {
  padding:
    env(safe-area-inset-top, 20px)
    env(safe-area-inset-right, 20px)
    env(safe-area-inset-bottom, 20px)
    env(safe-area-inset-left, 20px);
}</pre>

<p>In addition, unlike custom properties, which cannot be used outside of declarations, the <code>env()</code> function can be used in place of any part of a property value, or any part of a descriptor (e.g. in <a href="/en-US/docs/Web/CSS/@media">Media query rules</a>). As the spec evolves, it may also be usable in other places such as selectors.</p>

<p>Originally provided by the iOS browser to allow developers to place their content in a safe area of the viewport, the <code>safe-area-inset-*</code> values defined in the specification can be used to help ensure content is visible even to viewers using non‑rectangular displays.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css; no-line-numbers notranslate">/* Using the four safe area inset values with no fallback values */
env(safe-area-inset-top);
env(safe-area-inset-right);
env(safe-area-inset-bottom);
env(safe-area-inset-left);

/* Using them with fallback values */
env(safe-area-inset-top, 20px);
env(safe-area-inset-right, 1em);
env(safe-area-inset-bottom, 0.5vh);
env(safe-area-inset-left, 1.4rem);
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code id="safe-area-inset-top" style="white-space: nowrap;">safe-area-inset-top</code>, <code id="safe-area-inset-right" style="white-space: nowrap;">safe-area-inset-right</code>, <code id="safe-area-inset-bottom" style="white-space: nowrap;">safe-area-inset-bottom</code>, <code id="safe-area-inset-left" style="white-space: nowrap;">safe-area-inset-left</code></dt>
 <dd>The <code style="white-space: nowrap;">safe-area-inset-*</code> variables are four environment variables that define a rectangle by its top, right, bottom, and left insets from the edge of the viewport, which is safe to put content into without risking it being cut off by the shape of a non‑rectangular display. For rectangular viewports, like your average laptop monitor, their value is equal to zero. For non-rectangular displays — like a round watch face — the four values set by the user agent form a rectangle such that all content inside the rectangle is visible.</dd>
</dl>

<p><strong>Note</strong>: Unlike other CSS properties, user agent-defined property names are case-sensitive.</p>

<h3 id="Formal_syntax">Formal syntax</h3>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<p>The below example makes use of the optional second parameter of <code>env()</code>, which allows you to provide a fallback value in case the environment variable is not available.</p>

<pre class="brush: html notranslate">&lt;p&gt;
  If the &lt;code&gt;env()&lt;/code&gt; function is supported in your browser,
  this paragraph’s text will have 50px of padding between it and
  the left border — but not the top, right and bottom.
  This is because the accompanying CSS is the equivalent of
  &lt;code&gt;padding: 0 0 0 50px&lt;/code&gt;, because, unlike other CSS
  properties, user agent property names are case-sensitive.
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">p {
  width: 300px;
  border: 2px solid red;
  padding:
    env(safe-area-inset-top, 50px)
    env(safe-area-inset-right, 50px)
    env(safe-area-inset-bottom, 50px)
    env(SAFE-AREA-INSET-LEFT, 50px);
}</pre>

<p>{{EmbedLiveSample("Examples")}}</p>

<h3 id="Example_values">Example values</h3>

<pre class="brush: css notranslate">padding: env(safe-area-inset-bottom, 50px); /* zero for all rectangular user agents */
padding: env(Safe-area-inset-bottom, 50px); /* 50px because UA properties are case sensitive */
padding: env(x, 50px 20px); /* as if padding: '50px 20px' were set because x is not a valid environment variable */
padding: env(x, 50px, 20px); /* ignored because '50px, 20px' is not a valid padding value and x is not a valid environment variable */
</pre>

<p>The syntax of the fallback, like that of custom properties, allows commas. But, if the property value doesn't support commas, the value is not valid.</p>

<p><strong>Note</strong>: User agent properties are not reset by the <a href="/en-US/docs/Web/CSS/all">all</a> property.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS3 Environment Variables", "#env-function", "env()")}}</td>
   <td>{{Spec2("CSS3 Environment Variables")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.custom-property.env")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("var", "var(…)")}}</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Variables">CSS Custom Properties for Cascading Variables</a></li>
 <li><a href="/en-US/docs/Web/CSS/--*">Custom Properties (--*)</a></li>
 <li><a href="/en-US/docs/Web/CSS/Using_CSS_variables">Using CSS custom properties (variables)</a></li>
 <li>{{CSSxRef("@viewport/viewport-fit", "viewport-fit (@viewport)")}}</li>
</ul>
